/*
Definitions and changes to make it work with gcc
*/
#include <pc.h>
#include "dLCDrtns.h"
#define outport outportb
#define inport  inportb
/* LCD connections
**
** LCD      PrinterPort
**
** D0 		   D0
** D1		   D1
** D2		   D2
** D3		   D3
** D4		   D4
** D5		   D5
** D6		   D6
** D7	       D7
**
** E		   Strobe      (pin 1 )	   ctrlreg_Bit0
** R/W		   Tied to ground >> No busy flag check or any other read from display will be done.
** RS		   Auto Feed   (pin 14)	   ctrlreg_Bit1
** CSA 		   Initialize  (pin 16)	   ctrlreg_Bit2
** CSB	 	   Select      (pin 17)	   ctrlreg_Bit3
*/

/* Some macros */
#define LCD_EnablePin(x)  pport_DataStrobe(x)
#define LCD_RegSlctPin(x) pport_Autofeed(x)
#define LCD_Data(x)		  pport_Data(x)
#define LCD_CSLeftPin(x)  pport_InitOut(x)
#define LCD_CSRightPin(x) pport_Select(x)

/*
** LCD_WriteInstr: Writes a control instruction to the LCD
*/
void LCD_WriteInstr (unsigned char data)
{
	LCD_EnablePin(0);	// E=0
	LCD_RegSlctPin(0);  // RS=0
	LCD_Data(data);	// data on port
	LCD_EnablePin(1);	// E=1
	//delay(1);													// 1 ms delay
	LCD_EnablePin(0);	// E=0
	//delay(10);													// 10ms delay
}


/*
** LCD_WriteData: Writes a byte of data to the LCD
*/
void LCD_WriteData (unsigned char instr)
{
	LCD_EnablePin(0);	// E=0
	LCD_RegSlctPin(1);  // RS=1
	LCD_Data(instr);	// instruction on port
	LCD_EnablePin(1);	// E=1
	//delay(1);													// 1 ms delay
	LCD_EnablePin(0);	// E=0
	//delay(1);													// 1 ms delay
}

/*

*/



/*
** LCD_EnableSide: Enebale one controller & disable the other
*/
#define RIGHT 0
#define LEFT 1
void LCD_SelectSide(unsigned char side)
{
	if(side == RIGHT)
	{
		LCD_CSLeftPin(1);
		LCD_CSRightPin(0);
	}
	else
	{
		LCD_CSLeftPin(0);
		LCD_CSRightPin(1);
	}


}

/*
** GLCD_Init: Initialize the LCD
*/
void LCD_Init (void)
{
	LCD_WriteInstr(0x38);
	LCD_WriteInstr(0x38);
	LCD_WriteInstr(0x38);
	LCD_WriteInstr(0x06);
	LCD_WriteInstr(0x0c);
}

/*
** LCD_Init: Initialize the LCD
*/
void GLCD_Init (void)
{
	LCD_WriteInstr(0x3f);
	LCD_WriteInstr(0x40);
	LCD_WriteInstr(0xb8);
	LCD_WriteInstr(0xc0);
}
